<script lang="ts">
  import { onMount, onDestroy } from 'svelte';
  import { Editor, nodePasteRule } from '@tiptap/core';
  import Mention from '@tiptap/extension-mention';
  import Placeholder from '@tiptap/extension-placeholder';
  import Document from '@tiptap/extension-document';
  import Text from '@tiptap/extension-text';
  import Paragraph from '@tiptap/extension-paragraph';
  import Dropcursor from '@tiptap/extension-dropcursor';
  import History from '@tiptap/extension-history';
  import suggestion from './suggestion';

  let element: Element | undefined;
  let editor: Editor;

  // Define props
  export let value: string = '';
  export let placeholder: string = '';
  export let autofocus: boolean = false;
  let className: string = '';
  export { className as class };

  const MentionWithPasteRule = Mention.extend({
    addPasteRules() {
      return [
        nodePasteRule({
          find: /\$([a-zA-Z0-9]+)/g,
          type: this.type,
          getAttributes: (match) => {
            return { label: match[1] };
          },
        }),
      ];
    },
  });

  onMount(() => {
    editor = new Editor({
      // See https://tiptap.dev/docs/editor/api/editor#settings for available options
      element: element,
      extensions: [
        // Enable the required extensions Document, Text, and Paragraph. Note: instead StarterKit can be used to enable multiple styles. See also https://tiptap.dev/docs/editor/api/extensions and https://tiptap.dev/docs/editor/api/nodes and https://tiptap.dev/docs/editor/api/marks
        Document,
        Text,
        Paragraph, // IMPROVE: disable enter keys to enforce single line text. Write an alternative for Paragraph? See also https://github.com/ueberdosis/tiptap/discussions/2948, of which the proposed solutions do not seem to work and also seem not to affect pasting

        // Enable other useful extensions
        Dropcursor,
        History,

        // Enable mentions for variables
        MentionWithPasteRule.configure({
          HTMLAttributes: {
            class: 'variable', // The class of the element once inserted
          },
          suggestion,
        }),

        // Allow adding placeholders
        Placeholder.configure({
          placeholder: placeholder,
        }),
      ],
      enableInputRules: false, // Disable default input rules, see https://tiptap.dev/docs/editor/guide/custom-extensions#input-rules
      enablePasteRules: [MentionWithPasteRule], // Enable paste rules for mentions, see https://tiptap.dev/docs/editor/guide/custom-extensions#paste-rules
      content: value,
      autofocus,
      editorProps: {
        attributes: {
          class: className, // Note: instead of on the parent div, since the editor element is focused, etc.
        },
      },
      onTransaction: () => {
        // Force re-render so `editor.isActive` works as expected
        editor = editor;
      },
      onUpdate: () => {
        value = editor.getText();
      },
    });
  });

  onDestroy(() => {
    if (editor) {
      editor.destroy();
    }
  });
</script>

<div bind:this={element} class="inline-block" />

<style lang="postcss">
  :global(.variable) {
    @apply -my-1 inline-block rounded bg-slate-500 px-2 py-1 font-mono text-sm text-white;
  }

  :global(.variable-suggestions) {
    @apply absolute z-10 mt-1.5 max-h-[15.25rem] w-48 overflow-y-auto rounded-lg bg-white py-2 text-sm shadow;
  }

  /* Placeholder */
  :global(.tiptap p.is-editor-empty:first-child::before) {
    @apply pointer-events-none float-left h-0 text-gray-400;
    content: attr(data-placeholder);
  }
</style>
